# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from image_exposure_msgs/SequenceExposureStatistics.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import image_exposure_msgs.msg
import statistics_msgs.msg

class SequenceExposureStatistics(genpy.Message):
  _md5sum = "2a4f3187c50e7b3544984e9e28ce4328"
  _type = "image_exposure_msgs/SequenceExposureStatistics"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# exposure statistics for a multi-exposure HDR sequence
ImageExposureStatistics[] exposures
uint32 underExposed 		# number of pixels underexposed in longest exposure
uint32 overExposed  		# number of pixels overexposed in shortest
float64 meanIrradiance 		# mean irradiance of all properly exposed pixels in all images in the sequence
float64 minMeasurableIrradiance
float64 maxMeasurableIrradiance
float64 minObservedIrradiance
float64 maxObservedIrradiance


================================================================================
MSG: image_exposure_msgs/ImageExposureStatistics
# message for exposure statistics reported a single image
time stamp         # image time stamp
string time_reference # The name of the reference clock for this message's timestamp.
float32 shutterms  # shutter durations in ms
float32 gaindb     # gain in decibels
# pixel exposure and latency statistics
uint32 underExposed # number of pixels underexposed
uint32 overExposed  # number of pixels overexposed
statistics_msgs/Stats1D pixelVal   # distribution of pixel values in the image
statistics_msgs/Stats1D pixelAge   # distribution of pixel ages in frames
# irradiance = pixelval/(shutterTime*10^(gaindb/10.0))
float64 meanIrradiance
float64 minMeasurableIrradiance
float64 maxMeasurableIrradiance
float64 minObservedIrradiance
float64 maxObservedIrradiance



================================================================================
MSG: statistics_msgs/Stats1D
# statistics of a 1-D distribution
float64 min
float64 max 
float64 mean 
float64 variance
int64 N
"""
  __slots__ = ['exposures','underExposed','overExposed','meanIrradiance','minMeasurableIrradiance','maxMeasurableIrradiance','minObservedIrradiance','maxObservedIrradiance']
  _slot_types = ['image_exposure_msgs/ImageExposureStatistics[]','uint32','uint32','float64','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       exposures,underExposed,overExposed,meanIrradiance,minMeasurableIrradiance,maxMeasurableIrradiance,minObservedIrradiance,maxObservedIrradiance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SequenceExposureStatistics, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.exposures is None:
        self.exposures = []
      if self.underExposed is None:
        self.underExposed = 0
      if self.overExposed is None:
        self.overExposed = 0
      if self.meanIrradiance is None:
        self.meanIrradiance = 0.
      if self.minMeasurableIrradiance is None:
        self.minMeasurableIrradiance = 0.
      if self.maxMeasurableIrradiance is None:
        self.maxMeasurableIrradiance = 0.
      if self.minObservedIrradiance is None:
        self.minObservedIrradiance = 0.
      if self.maxObservedIrradiance is None:
        self.maxObservedIrradiance = 0.
    else:
      self.exposures = []
      self.underExposed = 0
      self.overExposed = 0
      self.meanIrradiance = 0.
      self.minMeasurableIrradiance = 0.
      self.maxMeasurableIrradiance = 0.
      self.minObservedIrradiance = 0.
      self.maxObservedIrradiance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.exposures)
      buff.write(_struct_I.pack(length))
      for val1 in self.exposures:
        _v1 = val1.stamp
        _x = _v1
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.time_reference
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2f2I().pack(_x.shutterms, _x.gaindb, _x.underExposed, _x.overExposed))
        _v2 = val1.pixelVal
        _x = _v2
        buff.write(_get_struct_4dq().pack(_x.min, _x.max, _x.mean, _x.variance, _x.N))
        _v3 = val1.pixelAge
        _x = _v3
        buff.write(_get_struct_4dq().pack(_x.min, _x.max, _x.mean, _x.variance, _x.N))
        _x = val1
        buff.write(_get_struct_5d().pack(_x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance))
      _x = self
      buff.write(_get_struct_2I5d().pack(_x.underExposed, _x.overExposed, _x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.exposures is None:
        self.exposures = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.exposures = []
      for i in range(0, length):
        val1 = image_exposure_msgs.msg.ImageExposureStatistics()
        _v4 = val1.stamp
        _x = _v4
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.time_reference = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.time_reference = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.shutterms, _x.gaindb, _x.underExposed, _x.overExposed,) = _get_struct_2f2I().unpack(str[start:end])
        _v5 = val1.pixelVal
        _x = _v5
        start = end
        end += 40
        (_x.min, _x.max, _x.mean, _x.variance, _x.N,) = _get_struct_4dq().unpack(str[start:end])
        _v6 = val1.pixelAge
        _x = _v6
        start = end
        end += 40
        (_x.min, _x.max, _x.mean, _x.variance, _x.N,) = _get_struct_4dq().unpack(str[start:end])
        _x = val1
        start = end
        end += 40
        (_x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance,) = _get_struct_5d().unpack(str[start:end])
        self.exposures.append(val1)
      _x = self
      start = end
      end += 48
      (_x.underExposed, _x.overExposed, _x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance,) = _get_struct_2I5d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.exposures)
      buff.write(_struct_I.pack(length))
      for val1 in self.exposures:
        _v7 = val1.stamp
        _x = _v7
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.time_reference
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2f2I().pack(_x.shutterms, _x.gaindb, _x.underExposed, _x.overExposed))
        _v8 = val1.pixelVal
        _x = _v8
        buff.write(_get_struct_4dq().pack(_x.min, _x.max, _x.mean, _x.variance, _x.N))
        _v9 = val1.pixelAge
        _x = _v9
        buff.write(_get_struct_4dq().pack(_x.min, _x.max, _x.mean, _x.variance, _x.N))
        _x = val1
        buff.write(_get_struct_5d().pack(_x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance))
      _x = self
      buff.write(_get_struct_2I5d().pack(_x.underExposed, _x.overExposed, _x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.exposures is None:
        self.exposures = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.exposures = []
      for i in range(0, length):
        val1 = image_exposure_msgs.msg.ImageExposureStatistics()
        _v10 = val1.stamp
        _x = _v10
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.time_reference = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.time_reference = str[start:end]
        _x = val1
        start = end
        end += 16
        (_x.shutterms, _x.gaindb, _x.underExposed, _x.overExposed,) = _get_struct_2f2I().unpack(str[start:end])
        _v11 = val1.pixelVal
        _x = _v11
        start = end
        end += 40
        (_x.min, _x.max, _x.mean, _x.variance, _x.N,) = _get_struct_4dq().unpack(str[start:end])
        _v12 = val1.pixelAge
        _x = _v12
        start = end
        end += 40
        (_x.min, _x.max, _x.mean, _x.variance, _x.N,) = _get_struct_4dq().unpack(str[start:end])
        _x = val1
        start = end
        end += 40
        (_x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance,) = _get_struct_5d().unpack(str[start:end])
        self.exposures.append(val1)
      _x = self
      start = end
      end += 48
      (_x.underExposed, _x.overExposed, _x.meanIrradiance, _x.minMeasurableIrradiance, _x.maxMeasurableIrradiance, _x.minObservedIrradiance, _x.maxObservedIrradiance,) = _get_struct_2I5d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2I5d = None
def _get_struct_2I5d():
    global _struct_2I5d
    if _struct_2I5d is None:
        _struct_2I5d = struct.Struct("<2I5d")
    return _struct_2I5d
_struct_2f2I = None
def _get_struct_2f2I():
    global _struct_2f2I
    if _struct_2f2I is None:
        _struct_2f2I = struct.Struct("<2f2I")
    return _struct_2f2I
_struct_4dq = None
def _get_struct_4dq():
    global _struct_4dq
    if _struct_4dq is None:
        _struct_4dq = struct.Struct("<4dq")
    return _struct_4dq
_struct_5d = None
def _get_struct_5d():
    global _struct_5d
    if _struct_5d is None:
        _struct_5d = struct.Struct("<5d")
    return _struct_5d
